#include <Adafruit_NeoPixel.h>
 
#define ledPIN 10
#define potPIN 2 //analog pin 1, actually marked 2

int val = 0;       // variable to store the value coming from the sensor
uint8_t r, g, b; 

 
// Parameter 1 = number of pixels in strip
// Parameter 2 = pin number (most are valid)
// Parameter 3 = pixel type flags, add together as needed:
//   NEO_KHZ800  800 KHz bitstream (most NeoPixel products w/WS2812 LEDs)
//   NEO_KHZ400  400 KHz (classic 'v1' (not v2) FLORA pixels, WS2811 drivers)
//   NEO_GRB     Pixels are wired for GRB bitstream (most NeoPixel products)
//   NEO_RGB     Pixels are wired for RGB bitstream (v1 FLORA pixels, not v2)
Adafruit_NeoPixel strip = Adafruit_NeoPixel(13, ledPIN, NEO_GRB + NEO_KHZ800);

void setup() {
  //r=255;
  //g=0;
  //b=0;
  pinMode(ledPIN, OUTPUT);  // declare the ledPin as an OUTPUT

  strip.begin();
  strip.setBrightness(255); //adjust brightness here
  strip.show(); // Initialize all pixels to 'off'
}
 
void loop() {
  //rainbowRGB(10);
  val = analogRead(potPIN);    // read the value from the sensor
  
 /** if (val<1) {
  colorWipe(strip.Color(255, 0, 0), 20); // Red
  } else  {
      if (val>1023) {
  colorWipe(strip.Color(0, 255, 0), 50); // Green
      }
      else {colorWipe(strip.Color(0, 0, 255), 10); // Blue}
      }
  }**/
  colorVal(val,10);
  
/*  if (val<50) {
      colorWipe(strip.Color(255, 0, 0), 10); // Red
  }
  else {
      colorWipe(strip.Color(0, 0, 255), 10); // Blue
  }*/
}

void colorVal(int v, uint8_t wait) {
  uint8_t r=0, g=0, b=0;
 
  if ((v>=0) && (v<256))
    {r=255;g=v;b=0;}
  if ((v>256) && (v<512))
    {r=512-v;g=255;b=0;}
  if ((v>512) && (v<768))
    {r=0;g=255;b=v-512;}
  if ((v>768) && (v<=1024))
    {r=0;g=1024-v;b=255;}
   
  for(uint16_t i=0; i<strip.numPixels(); i++) {
      strip.setPixelColor(i, r, g, b);
      strip.show();
      delay(wait);
  }
}

 
// Fill the dots one after the other with a color
void colorWipe(uint32_t c, uint8_t wait) {
  for(uint16_t i=0; i<strip.numPixels(); i++) {
      strip.setPixelColor(i, c);
      strip.show();
      delay(wait);
  }
}

void rainbowRGB(uint8_t wait) {
  uint16_t i;
    for(i=0; i<strip.numPixels(); i++) {
      nextRGB();
      strip.setPixelColor(i, r, g, b);
    }
    strip.show();
    delay(wait);
}
 
void nextRGB() {
    if ( r == 255 && g < 255 && b == 0 )  { g++; }
    if ( g == 255 && r > 0 && b == 0 )    { r--; }
    if ( g == 255 && b < 255 && r == 0 )  { b++; }
    if ( b == 255 && g > 0 && r == 0 )    { g--; }
    if ( b == 255 && r < 255 && g == 0 )  { r++; }
    if ( r == 255 && b > 0 && g == 0 )    { b--; }
}

